/*
 * $Header: /home/jerenkrantz/tmp/commons/commons-convert/cvs/home/cvs/jakarta-commons//resources/src/test/org/apache/commons/resources/impl/CollResources.java,v 1.7 2004/03/27 21:34:09 dgraham Exp $
 * $Revision: 1.7 $
 * $Date: 2004-03-27 16:34:10 -0500 (Sat, 27 Mar 2004) $
 *
 * ====================================================================
 *
 *  Copyright 2003-2004 The Apache Software Foundation
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

package org.apache.commons.resources.impl;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

/**
 * <p>Concrete implementation of {@link org.apache.commons.resources.Resources} for unit tests.</p>
 *
 * <p><strong>IMPLEMENTATION NOTE</strong> - The set of hard-coded resource
 * maps returned by <code>getLocaleMap()</code> below must *exactly*
 * match the resources stored in the <code>TestResources*.properties</code>
 * and <code>TestResources*.xml</code> resource files.</p>
 */
public class CollResources extends CollectionResourcesBase {


    // ----------------------------------------------------------- Constructors


    // Construct a test instance with the specified name and base URL
    public CollResources(String name, String base) {
        super(name, base);
    }


    // ----------------------------------------------------- Instance Variables


    // ------------------------------------------------------ Lifecycle Methods


    // ------------------------------------------------------------- Properties


    // ---------------------------------------------- Content Retrieval Methods


    // Concrete implementation of getLocaleMap()
    protected Map getLocaleMap(String baseUrl, Locale locale) {

        String language = locale.getLanguage();
        String country = locale.getCountry();
        String variant = locale.getVariant();
        if (variant.length() > 0) {
            return (new HashMap());
        }

        if (language.equals("en")) {
            if (country.equals("US")) {
                Map map = new HashMap();
                map.put("test.specific", "[en_US] SPECIFIC");
                return (map);
            } else if (country.equals("")) {
                Map map = new HashMap();
                map.put("test.specific", "[en] SPECIFIC");
                map.put("test.inherit", "[en] INHERIT");
                return (map);
            } else {
                return (new HashMap());
            }
        } else if (language.equals("fr")) {
            if (country.equals("")) {
                Map map = new HashMap();
                map.put("test.specific", "[fr] SPECIFIC");
                map.put("test.inherit", "[fr] INHERIT");
                return (map);
            } else {
                return (new HashMap());
            }
        } else if (language.equals("")) {
            if (country.equals("")) {
                Map map = new HashMap();
                map.put("test.base", "[Base] ONLY");
                map.put("test.specific", "[Base] SPECIFIC");
                map.put("test.inherit", "[Base] INHERIT");
                map.put("test.message", "[Base] REPLACE {0} WITH {1}");
                return (map);
            } else {
                return (new HashMap());
            }
        } else {
            return (new HashMap());
        }
    }


}
